ServletContext (Java Card API, Connected Edition)
Date: 2009-12-11

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.servlet
Interface ServletContext

    @TransactionType(value=NOT_SUPPORTED)
    public interface ServletContext

Defines a set of methods that a servlet uses to communicate with its servlet container, for example, to get the MIME type of a file, dispatch requests, or write to a log file.

There is one context per "web application" per Java Virtual Machine. (A "web application" is a collection of servlets and content installed under a specific subset of the server's URL namespace such as `/catalog` and possibly installed via a `.war` file.)

The `ServletContext` object is contained within the `ServletConfig` object, which the Web server provides the servlet when the servlet is initialized.

This Java Card interface is a subset of the Java Servlet API 2.4 ServletContext interface. Some methods have been pruned in an effort to reduce the size of this interface and its implementations and/or eliminate dependencies on unsupported features.

Since:
  Servlet 2.x, Java Card 3.0
See Also:
  `Servlet.getServletConfig()`, `ServletConfig.getServletContext()`

Method Summary
`Object` | `getAttribute(String name)` Returns the servlet container attribute with the given name, or `null` if there is no attribute by that name.
`Enumeration` | `getAttributeNames()` Returns an `Enumeration` containing the attribute names available within this servlet context.
`ServletContext` | `getContext(String uripath)` Returns a `ServletContext` object that corresponds to a specified URL on the server.
`String` | `getInitParameter(String name)` Returns a `String` containing the value of the named context-wide initialization parameter, or `null` if the parameter does not exist.
`Enumeration` | `getInitParameterNames()` Returns the names of the context's initialization parameters as an `Enumeration` of `String` objects, or an empty `Enumeration` if the context has no initialization parameters.
`int` | `getMajorVersion()` Returns the major version of the Java Servlet API that this servlet container supports.
`String` | `getMimeType(String file)` Returns the MIME type of the specified file, or `null` if the MIME type is not known.
`int` | `getMinorVersion()` Returns the minor version of the Servlet API that this servlet container supports.
`RequestDispatcher` | `getNamedDispatcher(String name)` Returns a `RequestDispatcher` object that acts as a wrapper for the named servlet.
`String` | `getRealPath(String path)` Returns a `String` containing the real path for a given virtual path.
`RequestDispatcher` | `getRequestDispatcher(String path)` Returns a `RequestDispatcher` object that acts as a wrapper for the resource located at the given path.
`InputStream` | `getResourceAsStream(String path)` Returns the resource located at the named path as an `InputStream` object.
`String` | `getServerInfo()` Returns the name and version of the servlet container on which the servlet is running.
`String` | `getServletContextName()` Returns the name of this web application corresponding to this ServletContext as specified in the deployment descriptor for this web application by the display-name element.
`void` | `log(String msg)` Writes the specified message to a servlet log file, usually an event log.
`void` | `log(String message, Throwable throwable)` Writes an explanatory message and a stack trace for a given `Throwable` exception to the servlet log file.
`void` | `removeAttribute(String name)` Removes the attribute with the given name from the servlet context.
`void` | `setAttribute(String name, Object object)` Binds an object to a given attribute name in this servlet context.

Method Detail

### getContext

    ServletContext getContext(String uripath)

  Returns a `ServletContext` object that corresponds to a specified URL on the server.

  This method allows servlets to gain access to the context for various parts of the server, and as needed obtain `RequestDispatcher` objects from the context. The given path must be begin with "/", is interpreted relative to the server's document root and is matched against the context roots of other web applications hosted on this container.

  In a security conscious environment, the servlet container may return `null` for a given URL.

  Parameters:
    `uripath` - a `String` specifying the context path of another web application in the container.
  Returns:
    the `ServletContext` object that corresponds to the named URL, or null if either none exists or the container wishes to restrict this access.
  See Also:
    `RequestDispatcher`

### getMajorVersion

    int getMajorVersion()

  Returns the major version of the Java Servlet API that this servlet container supports. All implementations that comply with Version 2.4 must have this method return the integer 2.

  Returns:
    2

### getMinorVersion

    int getMinorVersion()

  Returns the minor version of the Servlet API that this servlet container supports. All implementations that comply with Version 2.4 must have this method return the integer 4.

  Returns:
    4

### getMimeType

    String getMimeType(String file)

  Returns the MIME type of the specified file, or `null` if the MIME type is not known. The MIME type is determined by the configuration of the servlet container, and may be specified in a web application deployment descriptor. Common MIME types are `"text/html"` and `"image/gif"`.

  Parameters:
    `file` - a `String` specifying the name of a file
  Returns:
    a `String` specifying the file's MIME type

### getResourceAsStream

    InputStream getResourceAsStream(String path)

  Returns the resource located at the named path as an `InputStream` object.

  The data in the `InputStream` can be of any type or length. The path must begin with a "/" and is interpreted as relative to the current context root. This method returns `null` if no resource exists at the specified path.

  This method allows the servlet container to make a resource available to servlets from any source. Resources can be located on a file system, in a database, or in a `.war` file.

  This method is different from `java.lang.Class.getResourceAsStream`, which uses a class loader. This method allows servlet containers to make a resource available to a servlet from any location, without using a class loader.

  Parameters:
    `path` - a `String` specifying the path to the resource
  Returns:
    the `InputStream` returned to the servlet, or `null` if no resource exists at the specified path

### getRequestDispatcher

    RequestDispatcher getRequestDispatcher(String path)

  Returns a `RequestDispatcher` object that acts as a wrapper for the resource located at the given path. A `RequestDispatcher` object can be used to forward a request to the resource or to include the resource in a response. The resource can be dynamic or static.

  The pathname must begin with a "/" and is interpreted as relative to the current context root. Use `getContext` to obtain a `RequestDispatcher` for resources in foreign contexts. This method returns `null` if the `ServletContext` cannot return a `RequestDispatcher`.

  Parameters:
    `path` - a `String` specifying the pathname to the resource
  Returns:
    a `RequestDispatcher` object that acts as a wrapper for the resource at the specified path, or `null` if the `ServletContext` cannot return a `RequestDispatcher`
  See Also:
    `RequestDispatcher`, `getContext(java.lang.String)`

### getNamedDispatcher

    RequestDispatcher getNamedDispatcher(String name)

  Returns a `RequestDispatcher` object that acts as a wrapper for the named servlet.

  Servlets may be given names via server administration or via a web application deployment descriptor. A servlet instance can determine its name using `ServletConfig.getServletName()`.

  This method returns `null` if the `ServletContext` cannot return a `RequestDispatcher` for any reason.

  Parameters:
    `name` - a `String` specifying the name of a servlet to wrap
  Returns:
    a `RequestDispatcher` object that acts as a wrapper for the named servlet, or `null` if the `ServletContext` cannot return a `RequestDispatcher`
  See Also:
    `RequestDispatcher`, `getContext(java.lang.String)`, `ServletConfig.getServletName()`

### log

    void log(String msg)

  Writes the specified message to a servlet log file, usually an event log. The name and type of the servlet log file is specific to the servlet container.

  Parameters:
    `msg` - a `String` specifying the message to be written to the log file

### log

    void log(String message,
             Throwable throwable)

  Writes an explanatory message and a stack trace for a given `Throwable` exception to the servlet log file. The name and type of the servlet log file is specific to the servlet container, usually an event log.

  Parameters:
    `message` - a `String` that describes the error or exception
    `throwable` - the `Throwable` error or exception

### getRealPath

    String getRealPath(String path)

  Returns a `String` containing the real path for a given virtual path. For example, the path "/index.html" returns the absolute file path on the server's filesystem would be served by a request for "http://host/contextPath/index.html", where contextPath is the context path of this ServletContext..

  The real path returned will be in a form appropriate to the computer and operating system on which the servlet container is running, including the proper path separators. This method returns `null` if the servlet container cannot translate the virtual path to a real path for any reason (such as when the content is being made available from a `.war` archive).

  Parameters:
    `path` - a `String` specifying a virtual path
  Returns:
    a `String` specifying the real path, or null if the translation cannot be performed

### getServerInfo

    String getServerInfo()

  Returns the name and version of the servlet container on which the servlet is running.

  The form of the returned string is servername/versionnumber. For example, the JavaServer Web Development Kit may return the string `JavaServer Web Dev Kit/1.0`.

  The servlet container may return other optional information after the primary string in parentheses, for example, `JavaServer Web Dev Kit/1.0 (JDK 1.1.6; Windows NT 4.0 x86)`.

  Returns:
    a `String` containing at least the servlet container name and version number

### getInitParameter

    String getInitParameter(String name)

  Returns a `String` containing the value of the named context-wide initialization parameter, or `null` if the parameter does not exist.

  This method can make available configuration information useful to an entire "web application". For example, it can provide a webmaster's email address or the name of a system that holds critical data.

  Parameters:
    `name` - a `String` containing the name of the parameter whose value is requested
  Returns:
    a `String` containing at least the servlet container name and version number
  See Also:
    `ServletConfig.getInitParameter(java.lang.String)`

### getInitParameterNames

    Enumeration getInitParameterNames()

  Returns the names of the context's initialization parameters as an `Enumeration` of `String` objects, or an empty `Enumeration` if the context has no initialization parameters.

  Returns:
    an `Enumeration` of `String` objects containing the names of the context's initialization parameters
  See Also:
    `ServletConfig.getInitParameter(java.lang.String)`

### getAttribute

    Object getAttribute(String name)

  Returns the servlet container attribute with the given name, or `null` if there is no attribute by that name. An attribute allows a servlet container to give the servlet additional information not already provided by this interface. See your server documentation for information about its attributes. A list of supported attributes can be retrieved using `getAttributeNames`.

  The attribute is returned as a `java.lang.Object` or some subclass. Attribute names should follow the same convention as package names. The Java Servlet API specification reserves names matching `java.*`, `javax.*`, `javacard.*`, `javacardx.*`, `com.sun.*`, and `sun.*`.

  Parameters:
    `name` - a `String` specifying the name of the attribute
  Returns:
    an `Object` containing the value of the attribute, or `null` if no attribute exists matching the given name
  See Also:
    `getAttributeNames()`

### getAttributeNames

    Enumeration getAttributeNames()

  Returns an `Enumeration` containing the attribute names available within this servlet context. Use the `getAttribute(java.lang.String)` method with an attribute name to get the value of an attribute.

  Returns:
    an `Enumeration` of attribute names
  See Also:
    `getAttribute(java.lang.String)`

### setAttribute

    void setAttribute(String name,
                      Object object)

  Binds an object to a given attribute name in this servlet context. If the name specified is already used for an attribute, this method will replace the attribute with the new to the new attribute.

  If listeners are configured on the `ServletContext` the container notifies them accordingly.

  If a null value is passed, the effect is the same as calling `removeAttribute()`.

  Attribute names should follow the same convention as package names. The Java Servlet API specification reserves names matching `java.*`, `javax.*`, `javacard.*`, `javacardx.*`, `com.sun.*`, and `sun.*`.

  Parameters:
    `name` - a `String` specifying the name of the attribute
    `object` - an `Object` representing the attribute to be bound

### removeAttribute

    void removeAttribute(String name)

  Removes the attribute with the given name from the servlet context. After removal, subsequent calls to `getAttribute(java.lang.String)` to retrieve the attribute's value will return `null`.

  If listeners are configured on the `ServletContext` the container notifies them accordingly.

  Parameters:
    `name` - a `String` specifying the name of the attribute to be removed

### getServletContextName

    String getServletContextName()

  Returns the name of this web application corresponding to this ServletContext as specified in the deployment descriptor for this web application by the display-name element.

  Returns:
    The name of the web application or null if no name has been declared in the deployment descriptor.
  Since:
    Servlet 2.3

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2009 Sun Microsystems, Inc. All rights reserved.